/* gitg-credentials-manager.c generated by valac 0.44.7, the Vala compiler
 * generated from gitg-credentials-manager.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgit2-glib/ggit.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <libsecret/secret.h>
#include <stdio.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include "config.h"
#include <gobject/gvaluecollector.h>

#define GITG_TYPE_CREDENTIALS_MANAGER (gitg_credentials_manager_get_type ())
#define GITG_CREDENTIALS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManager))
#define GITG_CREDENTIALS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManagerClass))
#define GITG_IS_CREDENTIALS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_CREDENTIALS_MANAGER))
#define GITG_IS_CREDENTIALS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_CREDENTIALS_MANAGER))
#define GITG_CREDENTIALS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManagerClass))

typedef struct _GitgCredentialsManager GitgCredentialsManager;
typedef struct _GitgCredentialsManagerClass GitgCredentialsManagerClass;
typedef struct _GitgCredentialsManagerPrivate GitgCredentialsManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	GITG_AUTHENTICATION_LIFE_TIME_FORGET,
	GITG_AUTHENTICATION_LIFE_TIME_SESSION,
	GITG_AUTHENTICATION_LIFE_TIME_FOREVER
} GitgAuthenticationLifeTime;

#define GITG_TYPE_AUTHENTICATION_LIFE_TIME (gitg_authentication_life_time_get_type ())
typedef struct _Block5Data Block5Data;
#define _gitg_credentials_manager_unref0(var) ((var == NULL) ? NULL : (var = (gitg_credentials_manager_unref (var), NULL)))

#define GITG_TYPE_AUTHENTICATION_DIALOG (gitg_authentication_dialog_get_type ())
#define GITG_AUTHENTICATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialog))
#define GITG_AUTHENTICATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialogClass))
#define GITG_IS_AUTHENTICATION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_AUTHENTICATION_DIALOG))
#define GITG_IS_AUTHENTICATION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_AUTHENTICATION_DIALOG))
#define GITG_AUTHENTICATION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialogClass))

typedef struct _GitgAuthenticationDialog GitgAuthenticationDialog;
typedef struct _GitgAuthenticationDialogClass GitgAuthenticationDialogClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
typedef struct _GitgParamSpecCredentialsManager GitgParamSpecCredentialsManager;

typedef enum  {
	GITG_CREDENTIALS_ERROR_CANCELLED
} GitgCredentialsError;
#define GITG_CREDENTIALS_ERROR gitg_credentials_error_quark ()
struct _GitgCredentialsManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GitgCredentialsManagerPrivate * priv;
};

struct _GitgCredentialsManagerClass {
	GTypeClass parent_class;
	void (*finalize) (GitgCredentialsManager *self);
};

struct _GitgCredentialsManagerPrivate {
	GgitConfig* d_config;
	GtkWindow* d_window;
	GeeHashMap* d_usermap;
	gboolean d_save_user_in_config;
	gchar* d_last_user;
	GeeHashMap* d_auth_tried;
};

struct _Block5Data {
	int _ref_count_;
	GitgCredentialsManager* self;
	GMutex mutex;
	GCond cond;
	GtkResponseType response;
	gchar* password;
	gchar* newusername;
	GitgAuthenticationLifeTime lifetime;
	gchar* url;
	gchar* username;
};

struct _GitgParamSpecCredentialsManager {
	GParamSpec parent_instance;
};

static gint GitgCredentialsManager_private_offset;
static gpointer gitg_credentials_manager_parent_class = NULL;
static SecretSchema* gitg_credentials_manager_s_secret_schema;
static SecretSchema* gitg_credentials_manager_s_secret_schema = NULL;
static GRegex* gitg_credentials_manager_s_ssh_short_form;
static GRegex* gitg_credentials_manager_s_ssh_short_form = NULL;

GQuark gitg_credentials_error_quark (void);
gpointer gitg_credentials_manager_ref (gpointer instance);
void gitg_credentials_manager_unref (gpointer instance);
GParamSpec* gitg_param_spec_credentials_manager (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags);
void gitg_value_set_credentials_manager (GValue* value,
                                         gpointer v_object);
void gitg_value_take_credentials_manager (GValue* value,
                                          gpointer v_object);
gpointer gitg_value_get_credentials_manager (const GValue* value);
GType gitg_credentials_manager_get_type (void) G_GNUC_CONST;
GitgCredentialsManager* gitg_credentials_manager_new (GgitConfig* config,
                                                      GtkWindow* window,
                                                      gboolean save_user_in_config);
GitgCredentialsManager* gitg_credentials_manager_construct (GType object_type,
                                                            GgitConfig* config,
                                                            GtkWindow* window,
                                                            gboolean save_user_in_config);
static gchar* gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                             const gchar* host);
static gint _____lambda39_ (GitgCredentialsManager* self,
                     GMatchInfo* info,
                     const gchar* value);
static gint ______lambda39__ggit_config_match_callback (GMatchInfo* match_info,
                                                 const gchar* value,
                                                 gpointer self);
static GgitCred* gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                                     const gchar* url,
                                                     const gchar* scheme,
                                                     const gchar* host,
                                                     const gchar* username,
                                                     GError** error);
GType gitg_authentication_life_time_get_type (void) G_GNUC_CONST;
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda40_ (Block5Data* _data5_);
GType gitg_authentication_dialog_get_type (void) G_GNUC_CONST;
GitgAuthenticationDialog* gitg_authentication_dialog_new (const gchar* url,
                                                          const gchar* username,
                                                          gboolean failed);
GitgAuthenticationDialog* gitg_authentication_dialog_construct (GType object_type,
                                                                const gchar* url,
                                                                const gchar* username,
                                                                gboolean failed);
const gchar* gitg_authentication_dialog_get_username (GitgAuthenticationDialog* self);
const gchar* gitg_authentication_dialog_get_password (GitgAuthenticationDialog* self);
GitgAuthenticationLifeTime gitg_authentication_dialog_get_life_time (GitgAuthenticationDialog* self);
static gboolean ___lambda40__gsource_func (gpointer self);
static void _g_free0_ (gpointer var);
static void ___lambda41_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda41__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void ___lambda42_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda42__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static GgitCred* gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                                    const gchar* url,
                                                    const gchar* username,
                                                    GError** error);
static void _vala_SoupURI_free (SoupURI* self);
GgitCred* gitg_credentials_manager_credentials (GitgCredentialsManager* self,
                                                const gchar* url,
                                                const gchar* username,
                                                GgitCredtype allowed_types,
                                                GError** error);
static void gitg_credentials_manager_finalize (GitgCredentialsManager * obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

GQuark
gitg_credentials_error_quark (void)
{
	return g_quark_from_static_string ("gitg-credentials-error-quark");
}

static inline gpointer
gitg_credentials_manager_get_instance_private (GitgCredentialsManager* self)
{
	return G_STRUCT_MEMBER_P (self, GitgCredentialsManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../libgitg/gitg-credentials-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 222 "gitg-credentials-manager.c"
}

GitgCredentialsManager*
gitg_credentials_manager_construct (GType object_type,
                                    GgitConfig* config,
                                    GtkWindow* window,
                                    gboolean save_user_in_config)
{
	GitgCredentialsManager* self = NULL;
	GgitConfig* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkWindow* _tmp2_;
#line 54 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 54 "../libgitg/gitg-credentials-manager.vala"
	self = (GitgCredentialsManager*) g_type_create_instance (object_type);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_config);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_config = _tmp0_;
#line 57 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_save_user_in_config = save_user_in_config;
#line 58 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ggit_credtype_get_type (), NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_auth_tried);
#line 58 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_auth_tried = _tmp1_;
#line 59 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = _g_object_ref0 (window);
#line 59 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_window);
#line 59 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_window = _tmp2_;
#line 54 "../libgitg/gitg-credentials-manager.vala"
	return self;
#line 261 "gitg-credentials-manager.c"
}

GitgCredentialsManager*
gitg_credentials_manager_new (GgitConfig* config,
                              GtkWindow* window,
                              gboolean save_user_in_config)
{
#line 54 "../libgitg/gitg-credentials-manager.vala"
	return gitg_credentials_manager_construct (GITG_TYPE_CREDENTIALS_MANAGER, config, window, save_user_in_config);
#line 271 "gitg-credentials-manager.c"
}

static gint
_____lambda39_ (GitgCredentialsManager* self,
                GMatchInfo* info,
                const gchar* value)
{
	gint result = 0;
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 74 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 74 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_usermap;
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_match_info_fetch (info, 1);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = _tmp1_;
#line 75 "../libgitg/gitg-credentials-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, value);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_tmp2_);
#line 76 "../libgitg/gitg-credentials-manager.vala"
	result = 0;
#line 76 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 301 "gitg-credentials-manager.c"
}

static gint
______lambda39__ggit_config_match_callback (GMatchInfo* match_info,
                                            const gchar* value,
                                            gpointer self)
{
	gint result;
	result = _____lambda39_ ((GitgCredentialsManager*) self, match_info, value);
#line 74 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 313 "gitg-credentials-manager.c"
}

static gchar*
gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                      const gchar* host)
{
	gchar* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	GError* _inner_error0_ = NULL;
#line 62 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 64 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_usermap;
#line 64 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp0_ == NULL) {
#line 333 "gitg-credentials-manager.c"
		GeeHashMap* _tmp1_;
		GgitConfig* _tmp2_;
#line 66 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 66 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (self->priv->d_usermap);
#line 66 "../libgitg/gitg-credentials-manager.vala"
		self->priv->d_usermap = _tmp1_;
#line 68 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = self->priv->d_config;
#line 68 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp2_ != NULL) {
#line 346 "gitg-credentials-manager.c"
			{
				GRegex* r = NULL;
				GRegex* _tmp3_;
				GgitConfig* _tmp4_ = NULL;
				GgitConfig* _tmp5_;
				GgitConfig* _tmp6_;
				GRegex* _tmp7_;
#line 72 "../libgitg/gitg-credentials-manager.vala"
				_tmp3_ = g_regex_new ("credential\\.(.*)\\.username", 0, 0, &_inner_error0_);
#line 72 "../libgitg/gitg-credentials-manager.vala"
				r = _tmp3_;
#line 72 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "gitg-credentials-manager.c"
					goto __catch27_g_error;
				}
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp5_ = self->priv->d_config;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp6_ = ggit_config_snapshot (_tmp5_, &_inner_error0_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp4_ = _tmp6_;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_regex_unref0 (r);
#line 373 "gitg-credentials-manager.c"
					goto __catch27_g_error;
				}
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp7_ = r;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				ggit_config_match_foreach (_tmp4_, _tmp7_, ______lambda39__ggit_config_match_callback, self, &_inner_error0_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_object_unref0 (_tmp4_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_regex_unref0 (r);
#line 386 "gitg-credentials-manager.c"
					goto __catch27_g_error;
				}
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp4_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_regex_unref0 (r);
#line 393 "gitg-credentials-manager.c"
			}
			goto __finally27;
			__catch27_g_error:
			{
				GError* e = NULL;
				FILE* _tmp8_;
				GError* _tmp9_;
				const gchar* _tmp10_;
#line 70 "../libgitg/gitg-credentials-manager.vala"
				e = _inner_error0_;
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_inner_error0_ = NULL;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp8_ = stderr;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp9_ = e;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp10_ = _tmp9_->message;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				fprintf (_tmp8_, "Could not get username from git config: %s\n", _tmp10_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_error_free0 (e);
#line 416 "gitg-credentials-manager.c"
			}
			__finally27:
#line 70 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../libgitg/gitg-credentials-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				g_clear_error (&_inner_error0_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 427 "gitg-credentials-manager.c"
			}
		}
	}
#line 86 "../libgitg/gitg-credentials-manager.vala"
	_tmp11_ = self->priv->d_usermap;
#line 86 "../libgitg/gitg-credentials-manager.vala"
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, host);
#line 86 "../libgitg/gitg-credentials-manager.vala"
	result = (gchar*) _tmp12_;
#line 86 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 439 "gitg-credentials-manager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	return _data5_;
#line 449 "gitg-credentials-manager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 459 "gitg-credentials-manager.c"
		GitgCredentialsManager* self;
#line 89 "../libgitg/gitg-credentials-manager.vala"
		self = _data5_->self;
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->newusername);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->password);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_vala_clear_GCond (&_data5_->cond);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_vala_clear_GMutex (&_data5_->mutex);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_gitg_credentials_manager_unref0 (self);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		g_slice_free (Block5Data, _data5_);
#line 479 "gitg-credentials-manager.c"
	}
}

static gboolean
__lambda40_ (Block5Data* _data5_)
{
	GitgCredentialsManager* self;
	gboolean result = FALSE;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GitgAuthenticationDialog* d = NULL;
	GgitCredtype _tmp2_;
	GitgAuthenticationDialog* _tmp3_;
	GitgAuthenticationDialog* _tmp4_;
	GtkWindow* _tmp5_;
	GitgAuthenticationDialog* _tmp6_;
	GtkResponseType _tmp7_;
	GitgAuthenticationDialog* _tmp19_;
#line 102 "../libgitg/gitg-credentials-manager.vala"
	self = _data5_->self;
#line 105 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_auth_tried;
#line 105 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _data5_->username);
#line 105 "../libgitg/gitg-credentials-manager.vala"
	tried = ((GgitCredtype) ((gintptr) _tmp1_)) & (~GGIT_CREDTYPE_SSH_KEY);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = tried;
#line 107 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = gitg_authentication_dialog_new (_data5_->url, _data5_->username, _tmp2_ != 0);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	g_object_ref_sink (_tmp3_);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	d = _tmp3_;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	_tmp4_ = d;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	_tmp5_ = self->priv->d_window;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp5_);
#line 110 "../libgitg/gitg-credentials-manager.vala"
	_tmp6_ = d;
#line 110 "../libgitg/gitg-credentials-manager.vala"
	_data5_->response = (GtkResponseType) gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 112 "../libgitg/gitg-credentials-manager.vala"
	_tmp7_ = _data5_->response;
#line 112 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp7_ == GTK_RESPONSE_OK) {
#line 529 "gitg-credentials-manager.c"
		GitgAuthenticationDialog* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		GitgAuthenticationDialog* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GitgAuthenticationDialog* _tmp16_;
		GitgAuthenticationLifeTime _tmp17_;
		GitgAuthenticationLifeTime _tmp18_;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = d;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = gitg_authentication_dialog_get_username (_tmp8_);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp10_ = _tmp9_;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->newusername);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_data5_->newusername = _tmp11_;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp12_ = d;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp13_ = gitg_authentication_dialog_get_password (_tmp12_);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp14_ = _tmp13_;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->password);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_data5_->password = _tmp15_;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp16_ = d;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp17_ = gitg_authentication_dialog_get_life_time (_tmp16_);
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp18_ = _tmp17_;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_data5_->lifetime = _tmp18_;
#line 573 "gitg-credentials-manager.c"
	}
#line 119 "../libgitg/gitg-credentials-manager.vala"
	_tmp19_ = d;
#line 119 "../libgitg/gitg-credentials-manager.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp19_);
#line 121 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_lock (&_data5_->mutex);
#line 122 "../libgitg/gitg-credentials-manager.vala"
	g_cond_signal (&_data5_->cond);
#line 123 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_unlock (&_data5_->mutex);
#line 125 "../libgitg/gitg-credentials-manager.vala"
	result = FALSE;
#line 125 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (d);
#line 125 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 591 "gitg-credentials-manager.c"
}

static gboolean
___lambda40__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda40_ (self);
#line 102 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 601 "gitg-credentials-manager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1515 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1516 "glib-2.0.vapi"
	result = self;
#line 1516 "glib-2.0.vapi"
	return result;
#line 614 "gitg-credentials-manager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 159 "../libgitg/gitg-credentials-manager.vala"
	var = (g_free (var), NULL);
#line 622 "gitg-credentials-manager.c"
}

static void
___lambda41_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 180 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (res != NULL);
#line 633 "gitg-credentials-manager.c"
	{
#line 183 "../libgitg/gitg-credentials-manager.vala"
		secret_password_store_finish (res, &_inner_error0_);
#line 183 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "gitg-credentials-manager.c"
			goto __catch29_g_error;
		}
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 181 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 181 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = stderr;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = e;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp0_, "Failed to store secret in keyring: %s\n", _tmp2_);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 664 "gitg-credentials-manager.c"
	}
	__finally29:
#line 181 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		return;
#line 675 "gitg-credentials-manager.c"
	}
}

static void
____lambda41__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 174 "../libgitg/gitg-credentials-manager.vala"
	___lambda41_ ((GitgCredentialsManager*) self, source_object, res);
#line 174 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_unref (self);
#line 688 "gitg-credentials-manager.c"
}

static void
___lambda42_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 193 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (res != NULL);
#line 699 "gitg-credentials-manager.c"
	{
#line 196 "../libgitg/gitg-credentials-manager.vala"
		secret_password_clear_finish (res, &_inner_error0_);
#line 196 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 705 "gitg-credentials-manager.c"
			goto __catch30_g_error;
		}
	}
	goto __finally30;
	__catch30_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 194 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 194 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = stderr;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = e;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp0_, "Failed to clear secret from keyring: %s\n", _tmp2_);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 730 "gitg-credentials-manager.c"
	}
	__finally30:
#line 194 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		return;
#line 741 "gitg-credentials-manager.c"
	}
}

static void
____lambda42__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 193 "../libgitg/gitg-credentials-manager.vala"
	___lambda42_ ((GitgCredentialsManager*) self, source_object, res);
#line 193 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_unref (self);
#line 754 "gitg-credentials-manager.c"
}

static GgitCred*
gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                           const gchar* url,
                                           const gchar* scheme,
                                           const gchar* host,
                                           const gchar* username,
                                           GError** error)
{
	GgitCred* result = NULL;
	Block5Data* _data5_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkResponseType _tmp4_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GHashTable* attributes = NULL;
	GHashFunc _tmp30_;
	GEqualFunc _tmp31_;
	GHashTable* _tmp32_;
	GHashTable* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GHashTable* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GHashTable* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	GitgAuthenticationLifeTime _tmp43_;
	GeeHashMap* _tmp56_;
	const gchar* _tmp57_;
	GgitCredPlaintext* _tmp58_ = NULL;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	GgitCredPlaintext* _tmp61_;
	GgitCredPlaintext* _tmp62_;
	GError* _inner_error0_ = NULL;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->_ref_count_ = 1;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->self = gitg_credentials_manager_ref (self);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = g_strdup (url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_data5_->url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->url = _tmp0_;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup (username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_data5_->username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->username = _tmp1_;
#line 91 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_init (&_data5_->mutex);
#line 92 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_lock (&_data5_->mutex);
#line 94 "../libgitg/gitg-credentials-manager.vala"
	g_cond_init (&_data5_->cond);
#line 96 "../libgitg/gitg-credentials-manager.vala"
	_data5_->response = GTK_RESPONSE_CANCEL;
#line 98 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = g_strdup ("");
#line 98 "../libgitg/gitg-credentials-manager.vala"
	_data5_->password = _tmp2_;
#line 99 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = g_strdup ("");
#line 99 "../libgitg/gitg-credentials-manager.vala"
	_data5_->newusername = _tmp3_;
#line 100 "../libgitg/gitg-credentials-manager.vala"
	_data5_->lifetime = GITG_AUTHENTICATION_LIFE_TIME_FORGET;
#line 102 "../libgitg/gitg-credentials-manager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda40__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 128 "../libgitg/gitg-credentials-manager.vala"
	g_cond_wait (&_data5_->cond, &_data5_->mutex);
#line 129 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_unlock (&_data5_->mutex);
#line 131 "../libgitg/gitg-credentials-manager.vala"
	_tmp4_ = _data5_->response;
#line 131 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp4_ != GTK_RESPONSE_OK) {
#line 852 "gitg-credentials-manager.c"
		GError* _tmp5_;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_tmp5_ = g_error_new_literal (GITG_CREDENTIALS_ERROR, GITG_CREDENTIALS_ERROR_CANCELLED, "cancelled by user");
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = _tmp5_;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 133 "../libgitg/gitg-credentials-manager.vala"
		block5_data_unref (_data5_);
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_data5_ = NULL;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		return NULL;
#line 866 "gitg-credentials-manager.c"
	}
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_tmp6_ = _data5_->newusername;
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (self->priv->d_last_user);
#line 136 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_last_user = _tmp7_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
	if (_data5_->username == NULL) {
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = TRUE;
#line 880 "gitg-credentials-manager.c"
	} else {
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp11_ = _data5_->newusername;
#line 139 "../libgitg/gitg-credentials-manager.vala"
		if (g_strcmp0 (_tmp11_, _data5_->username) != 0) {
#line 889 "gitg-credentials-manager.c"
			GgitConfig* _tmp12_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp12_ = self->priv->d_config;
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = _tmp12_ != NULL;
#line 895 "gitg-credentials-manager.c"
		} else {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = FALSE;
#line 899 "gitg-credentials-manager.c"
		}
#line 139 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp10_) {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp9_ = self->priv->d_save_user_in_config;
#line 905 "gitg-credentials-manager.c"
		} else {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp9_ = FALSE;
#line 909 "gitg-credentials-manager.c"
		}
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = _tmp9_;
#line 913 "gitg-credentials-manager.c"
	}
#line 139 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp8_) {
#line 917 "gitg-credentials-manager.c"
		GeeHashMap* _tmp13_;
#line 141 "../libgitg/gitg-credentials-manager.vala"
		_tmp13_ = self->priv->d_usermap;
#line 141 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp13_ == NULL) {
#line 923 "gitg-credentials-manager.c"
			GeeHashMap* _tmp14_;
#line 143 "../libgitg/gitg-credentials-manager.vala"
			_tmp14_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 143 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (self->priv->d_usermap);
#line 143 "../libgitg/gitg-credentials-manager.vala"
			self->priv->d_usermap = _tmp14_;
#line 931 "gitg-credentials-manager.c"
		}
		{
			gchar* hid = NULL;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			GgitConfig* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			GeeHashMap* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp15_ = string_to_string (scheme);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp16_ = string_to_string (host);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp17_ = g_strconcat (_tmp15_, "://", _tmp16_, NULL);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			hid = _tmp17_;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp18_ = self->priv->d_config;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp19_ = hid;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp20_ = string_to_string (_tmp19_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp21_ = g_strconcat ("credential.", _tmp20_, ".username", NULL);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp22_ = _tmp21_;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp23_ = _data5_->newusername;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			ggit_config_set_string (_tmp18_, _tmp22_, _tmp23_, &_inner_error0_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (_tmp22_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (hid);
#line 975 "gitg-credentials-manager.c"
				goto __catch28_g_error;
			}
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp24_ = self->priv->d_usermap;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp25_ = hid;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp26_ = _data5_->newusername;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp24_, _tmp25_, _tmp26_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (hid);
#line 988 "gitg-credentials-manager.c"
		}
		goto __finally28;
		__catch28_g_error:
		{
			GError* e = NULL;
			FILE* _tmp27_;
			GError* _tmp28_;
			const gchar* _tmp29_;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			e = _inner_error0_;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_inner_error0_ = NULL;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp27_ = stderr;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp28_ = e;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp29_ = _tmp28_->message;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			fprintf (_tmp27_, "Failed to store username in config: %s\n", _tmp29_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_g_error_free0 (e);
#line 1011 "gitg-credentials-manager.c"
		}
		__finally28:
#line 146 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			block5_data_unref (_data5_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_data5_ = NULL;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1024 "gitg-credentials-manager.c"
		}
	}
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp30_ = g_str_hash;
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp31_ = g_str_equal;
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp32_ = g_hash_table_new_full (_tmp30_, _tmp31_, _g_free0_, _g_free0_);
#line 159 "../libgitg/gitg-credentials-manager.vala"
	attributes = _tmp32_;
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp33_ = attributes;
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp34_ = g_strdup ("scheme");
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp35_ = g_strdup (scheme);
#line 160 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp33_, _tmp34_, _tmp35_);
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp36_ = attributes;
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp37_ = g_strdup ("host");
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp38_ = g_strdup (host);
#line 161 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp36_, _tmp37_, _tmp38_);
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp39_ = attributes;
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp40_ = g_strdup ("user");
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp41_ = _data5_->newusername;
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp42_ = g_strdup (_tmp41_);
#line 162 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp39_, _tmp40_, _tmp42_);
#line 165 "../libgitg/gitg-credentials-manager.vala"
	_tmp43_ = _data5_->lifetime;
#line 165 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp43_ != GITG_AUTHENTICATION_LIFE_TIME_FORGET) {
#line 1065 "gitg-credentials-manager.c"
		gchar* collection = NULL;
		GitgAuthenticationLifeTime _tmp44_;
		SecretSchema* _tmp46_;
		GHashTable* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		const gchar* _tmp53_;
#line 167 "../libgitg/gitg-credentials-manager.vala"
		collection = NULL;
#line 169 "../libgitg/gitg-credentials-manager.vala"
		_tmp44_ = _data5_->lifetime;
#line 169 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp44_ == GITG_AUTHENTICATION_LIFE_TIME_SESSION) {
#line 1082 "gitg-credentials-manager.c"
			gchar* _tmp45_;
#line 171 "../libgitg/gitg-credentials-manager.vala"
			_tmp45_ = g_strdup (SECRET_COLLECTION_SESSION);
#line 171 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (collection);
#line 171 "../libgitg/gitg-credentials-manager.vala"
			collection = _tmp45_;
#line 1090 "gitg-credentials-manager.c"
		}
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp46_ = gitg_credentials_manager_s_secret_schema;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp47_ = attributes;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp48_ = collection;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp49_ = string_to_string (scheme);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp50_ = string_to_string (host);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp51_ = g_strconcat (_tmp49_, "://", _tmp50_, NULL);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp52_ = _tmp51_;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp53_ = _data5_->password;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		secret_password_storev (_tmp46_, _tmp47_, _tmp48_, _tmp52_, _tmp53_, NULL, ____lambda41__gasync_ready_callback, gitg_credentials_manager_ref (self));
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_tmp52_);
#line 165 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (collection);
#line 1114 "gitg-credentials-manager.c"
	} else {
		SecretSchema* _tmp54_;
		GHashTable* _tmp55_;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		_tmp54_ = gitg_credentials_manager_s_secret_schema;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		_tmp55_ = attributes;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		secret_password_clearv (_tmp54_, _tmp55_, NULL, ____lambda42__gasync_ready_callback, gitg_credentials_manager_ref (self));
#line 1124 "gitg-credentials-manager.c"
	}
#line 205 "../libgitg/gitg-credentials-manager.vala"
	_tmp56_ = self->priv->d_auth_tried;
#line 205 "../libgitg/gitg-credentials-manager.vala"
	_tmp57_ = _data5_->newusername;
#line 205 "../libgitg/gitg-credentials-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp56_, _tmp57_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp59_ = _data5_->newusername;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp60_ = _data5_->password;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp61_ = ggit_cred_plaintext_new (_tmp59_, _tmp60_, &_inner_error0_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp58_ = _tmp61_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../libgitg/gitg-credentials-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		_g_hash_table_unref0 (attributes);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		block5_data_unref (_data5_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		_data5_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
		return NULL;
#line 1152 "gitg-credentials-manager.c"
	}
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp62_ = _tmp58_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp58_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	result = (GgitCred*) _tmp62_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (_tmp58_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_g_hash_table_unref0 (attributes);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	block5_data_unref (_data5_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_data5_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 1170 "gitg-credentials-manager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1475 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1475 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1476 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1476 "glib-2.0.vapi"
	return result;
#line 1189 "gitg-credentials-manager.c"
}

static void
_vala_SoupURI_free (SoupURI* self)
{
#line 216 "../libgitg/gitg-credentials-manager.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 1197 "gitg-credentials-manager.c"
}

static GgitCred*
gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                          const gchar* url,
                                          const gchar* username,
                                          GError** error)
{
	GgitCred* result = NULL;
	gchar* user = NULL;
	gchar* host = NULL;
	gchar* _tmp0_;
	gchar* scheme = NULL;
	gchar* _tmp1_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 209 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 213 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = g_strdup ("local");
#line 213 "../libgitg/gitg-credentials-manager.vala"
	host = _tmp0_;
#line 214 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup ("file");
#line 214 "../libgitg/gitg-credentials-manager.vala"
	scheme = _tmp1_;
#line 216 "../libgitg/gitg-credentials-manager.vala"
	if (!string_contains (url, "://")) {
#line 1228 "gitg-credentials-manager.c"
		GMatchInfo* minfo = NULL;
		GRegex* _tmp2_;
		GMatchInfo* _tmp3_ = NULL;
		gboolean _tmp4_;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = gitg_credentials_manager_s_ssh_short_form;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_tmp4_ = g_regex_match (_tmp2_, url, 0, &_tmp3_);
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_g_match_info_unref0 (minfo);
#line 220 "../libgitg/gitg-credentials-manager.vala"
		minfo = _tmp3_;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp4_) {
#line 1243 "gitg-credentials-manager.c"
			gchar* _tmp5_;
			GMatchInfo* _tmp6_;
			gchar* _tmp7_;
#line 222 "../libgitg/gitg-credentials-manager.vala"
			_tmp5_ = g_strdup ("ssh");
#line 222 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 222 "../libgitg/gitg-credentials-manager.vala"
			scheme = _tmp5_;
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_tmp6_ = minfo;
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_tmp7_ = g_match_info_fetch_named (_tmp6_, "host");
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 223 "../libgitg/gitg-credentials-manager.vala"
			host = _tmp7_;
#line 1261 "gitg-credentials-manager.c"
		}
#line 216 "../libgitg/gitg-credentials-manager.vala"
		_g_match_info_unref0 (minfo);
#line 1265 "gitg-credentials-manager.c"
	} else {
		SoupURI* uri = NULL;
		SoupURI* _tmp8_;
		SoupURI* _tmp9_;
#line 228 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = soup_uri_new (url);
#line 228 "../libgitg/gitg-credentials-manager.vala"
		uri = _tmp8_;
#line 230 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = uri;
#line 230 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp9_ != NULL) {
#line 1278 "gitg-credentials-manager.c"
			SoupURI* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			SoupURI* _tmp13_;
			SoupURI* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = uri;
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp11_ = soup_uri_get_host (_tmp10_);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			host = _tmp12_;
#line 234 "../libgitg/gitg-credentials-manager.vala"
			_tmp13_ = uri;
#line 234 "../libgitg/gitg-credentials-manager.vala"
			if (!soup_uri_uses_default_port (_tmp13_)) {
#line 1300 "gitg-credentials-manager.c"
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				SoupURI* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp14_ = host;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp15_ = string_to_string (_tmp14_);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp16_ = uri;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp17_ = g_strdup_printf ("%u", soup_uri_get_port (_tmp16_));
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp18_ = _tmp17_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp19_ = g_strconcat (_tmp15_, ":", _tmp18_, NULL);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				host = _tmp19_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (_tmp18_);
#line 1325 "gitg-credentials-manager.c"
			}
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp20_ = uri;
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp21_ = soup_uri_get_scheme (_tmp20_);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			scheme = _tmp22_;
#line 1337 "gitg-credentials-manager.c"
		}
#line 216 "../libgitg/gitg-credentials-manager.vala"
		__vala_SoupURI_free0 (uri);
#line 1341 "gitg-credentials-manager.c"
	}
#line 243 "../libgitg/gitg-credentials-manager.vala"
	if (username == NULL) {
#line 1345 "gitg-credentials-manager.c"
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp23_ = scheme;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp25_ = host;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp27_ = g_strconcat (_tmp24_, "://", _tmp26_, NULL);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp28_ = _tmp27_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp29_ = gitg_credentials_manager_lookup_user (self, _tmp28_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		user = _tmp29_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_tmp28_);
#line 1373 "gitg-credentials-manager.c"
	} else {
		gchar* _tmp30_;
#line 250 "../libgitg/gitg-credentials-manager.vala"
		_tmp30_ = g_strdup (username);
#line 250 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 250 "../libgitg/gitg-credentials-manager.vala"
		user = _tmp30_;
#line 1382 "gitg-credentials-manager.c"
	}
#line 253 "../libgitg/gitg-credentials-manager.vala"
	_tmp31_ = user;
#line 253 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp31_ != NULL) {
#line 1388 "gitg-credentials-manager.c"
		GgitCredtype tried = 0U;
		GeeHashMap* _tmp32_;
		const gchar* _tmp33_;
		gpointer _tmp34_;
		GgitCredtype _tmp35_;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp32_ = self->priv->d_auth_tried;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp33_ = user;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp32_, _tmp33_);
#line 255 "../libgitg/gitg-credentials-manager.vala"
		tried = (GgitCredtype) ((gintptr) _tmp34_);
#line 257 "../libgitg/gitg-credentials-manager.vala"
		_tmp35_ = tried;
#line 257 "../libgitg/gitg-credentials-manager.vala"
		if ((_tmp35_ & GGIT_CREDTYPE_USERPASS_PLAINTEXT) == 0) {
#line 1406 "gitg-credentials-manager.c"
			gchar* secret = NULL;
			const gchar* _tmp43_;
			GeeHashMap* _tmp50_;
			const gchar* _tmp51_;
#line 259 "../libgitg/gitg-credentials-manager.vala"
			secret = NULL;
#line 1413 "gitg-credentials-manager.c"
			{
				gchar* _tmp36_ = NULL;
				SecretSchema* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp37_ = gitg_credentials_manager_s_secret_schema;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp38_ = scheme;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp39_ = host;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp40_ = user;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp41_ = secret_password_lookup_sync (_tmp37_, NULL, &_inner_error0_, "scheme", _tmp38_, "host", _tmp39_, "user", _tmp40_, NULL);
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp36_ = _tmp41_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1436 "gitg-credentials-manager.c"
					goto __catch31_g_error;
				}
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp42_ = _tmp36_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp36_ = NULL;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 263 "../libgitg/gitg-credentials-manager.vala"
				secret = _tmp42_;
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (_tmp36_);
#line 1449 "gitg-credentials-manager.c"
			}
			goto __finally31;
			__catch31_g_error:
			{
#line 261 "../libgitg/gitg-credentials-manager.vala"
				g_clear_error (&_inner_error0_);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_inner_error0_ = NULL;
#line 1458 "gitg-credentials-manager.c"
			}
			__finally31:
#line 261 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1475 "gitg-credentials-manager.c"
			}
#line 270 "../libgitg/gitg-credentials-manager.vala"
			_tmp43_ = secret;
#line 270 "../libgitg/gitg-credentials-manager.vala"
			if (_tmp43_ == NULL) {
#line 1481 "gitg-credentials-manager.c"
				GgitCred* _tmp44_ = NULL;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				GgitCred* _tmp48_;
				GgitCred* _tmp49_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp45_ = scheme;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp46_ = host;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp47_ = user;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp48_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp45_, _tmp46_, _tmp47_, &_inner_error0_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp44_ = _tmp48_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "../libgitg/gitg-credentials-manager.vala"
					g_propagate_error (error, _inner_error0_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (secret);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (scheme);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (host);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (user);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					return NULL;
#line 1512 "gitg-credentials-manager.c"
				}
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp49_ = _tmp44_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp44_ = NULL;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				result = _tmp49_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp44_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1532 "gitg-credentials-manager.c"
			}
#line 275 "../libgitg/gitg-credentials-manager.vala"
			_tmp50_ = self->priv->d_auth_tried;
#line 275 "../libgitg/gitg-credentials-manager.vala"
			_tmp51_ = user;
#line 275 "../libgitg/gitg-credentials-manager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, _tmp51_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
#line 1540 "gitg-credentials-manager.c"
			{
				GgitCredPlaintext* _tmp52_ = NULL;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				GgitCredPlaintext* _tmp55_;
				GgitCredPlaintext* _tmp56_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp53_ = user;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp54_ = secret;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp55_ = ggit_cred_plaintext_new (_tmp53_, _tmp54_, &_inner_error0_);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp52_ = _tmp55_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1557 "gitg-credentials-manager.c"
					goto __catch32_g_error;
				}
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp56_ = _tmp52_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp52_ = NULL;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				result = (GgitCred*) _tmp56_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp52_);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1578 "gitg-credentials-manager.c"
			}
			goto __finally32;
			__catch32_g_error:
			{
				GError* e = NULL;
				GgitCred* _tmp57_ = NULL;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
				const gchar* _tmp60_;
				GgitCred* _tmp61_;
				GgitCred* _tmp62_;
#line 277 "../libgitg/gitg-credentials-manager.vala"
				e = _inner_error0_;
#line 277 "../libgitg/gitg-credentials-manager.vala"
				_inner_error0_ = NULL;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp58_ = scheme;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp59_ = host;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp60_ = user;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp61_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp58_, _tmp59_, _tmp60_, &_inner_error0_);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp57_ = _tmp61_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../libgitg/gitg-credentials-manager.vala"
					_g_error_free0 (e);
#line 1608 "gitg-credentials-manager.c"
					goto __finally32;
				}
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp62_ = _tmp57_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp57_ = NULL;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				result = _tmp62_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp57_);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_error_free0 (e);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1631 "gitg-credentials-manager.c"
			}
			__finally32:
#line 277 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (secret);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1646 "gitg-credentials-manager.c"
		} else {
			GgitCred* _tmp63_ = NULL;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			const gchar* _tmp66_;
			GgitCred* _tmp67_;
			GgitCred* _tmp68_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp64_ = scheme;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp65_ = host;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp66_ = user;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp67_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp64_, _tmp65_, _tmp66_, &_inner_error0_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp63_ = _tmp67_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1676 "gitg-credentials-manager.c"
			}
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp68_ = _tmp63_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp63_ = NULL;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			result = _tmp68_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (_tmp63_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			return result;
#line 1694 "gitg-credentials-manager.c"
		}
	} else {
		GgitCred* _tmp69_ = NULL;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		const gchar* _tmp72_;
		GgitCred* _tmp73_;
		GgitCred* _tmp74_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp70_ = scheme;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp71_ = host;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp72_ = user;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp73_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp70_, _tmp71_, _tmp72_, &_inner_error0_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp69_ = _tmp73_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 293 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1725 "gitg-credentials-manager.c"
		}
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp74_ = _tmp69_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp69_ = NULL;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		result = _tmp74_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (_tmp69_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (scheme);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (host);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		return result;
#line 1743 "gitg-credentials-manager.c"
	}
#line 209 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (scheme);
#line 209 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (host);
#line 209 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (user);
#line 1751 "gitg-credentials-manager.c"
}

GgitCred*
gitg_credentials_manager_credentials (GitgCredentialsManager* self,
                                      const gchar* url,
                                      const gchar* username,
                                      GgitCredtype allowed_types,
                                      GError** error)
{
	GgitCred* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* uslookup = NULL;
	gchar* _tmp1_;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GgitCredtype untried_allowed_types = 0U;
	GgitCredtype _tmp5_;
	GgitCredtype _tmp6_;
	GError* _inner_error0_ = NULL;
#line 297 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 301 "../libgitg/gitg-credentials-manager.vala"
	if (username != NULL) {
#line 301 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = username;
#line 1781 "gitg-credentials-manager.c"
	} else {
#line 301 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = "";
#line 1785 "gitg-credentials-manager.c"
	}
#line 301 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 301 "../libgitg/gitg-credentials-manager.vala"
	uslookup = _tmp1_;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = self->priv->d_auth_tried;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = uslookup;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 302 "../libgitg/gitg-credentials-manager.vala"
	tried = (GgitCredtype) ((gintptr) _tmp4_);
#line 304 "../libgitg/gitg-credentials-manager.vala"
	_tmp5_ = tried;
#line 304 "../libgitg/gitg-credentials-manager.vala"
	untried_allowed_types = allowed_types & (~_tmp5_);
#line 306 "../libgitg/gitg-credentials-manager.vala"
	_tmp6_ = untried_allowed_types;
#line 306 "../libgitg/gitg-credentials-manager.vala"
	if ((_tmp6_ & GGIT_CREDTYPE_SSH_KEY) != 0) {
#line 1807 "gitg-credentials-manager.c"
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
		GgitCredtype _tmp9_;
		GgitCredSshKeyFromAgent* _tmp10_ = NULL;
		GgitCredSshKeyFromAgent* _tmp11_;
		GgitCredSshKeyFromAgent* _tmp12_;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = self->priv->d_auth_tried;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = uslookup;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = tried;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp8_, (gpointer) ((gintptr) (_tmp9_ | GGIT_CREDTYPE_SSH_KEY)));
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp11_ = ggit_cred_ssh_key_from_agent_new (username, &_inner_error0_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp10_ = _tmp11_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (uslookup);
#line 309 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1834 "gitg-credentials-manager.c"
		}
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp12_ = _tmp10_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp10_ = NULL;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		result = (GgitCred*) _tmp12_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (_tmp10_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (uslookup);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		return result;
#line 1848 "gitg-credentials-manager.c"
	} else {
#line 311 "../libgitg/gitg-credentials-manager.vala"
		if ((allowed_types & GGIT_CREDTYPE_USERPASS_PLAINTEXT) != 0) {
#line 1852 "gitg-credentials-manager.c"
			GgitCred* _tmp13_ = NULL;
			GgitCred* _tmp14_;
			GgitCred* _tmp15_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp14_ = gitg_credentials_manager_query_user_pass (self, url, username, &_inner_error0_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp13_ = _tmp14_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (uslookup);
#line 313 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1868 "gitg-credentials-manager.c"
			}
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp15_ = _tmp13_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp13_ = NULL;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			result = _tmp15_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (_tmp13_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (uslookup);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			return result;
#line 1882 "gitg-credentials-manager.c"
		}
	}
#line 316 "../libgitg/gitg-credentials-manager.vala"
	result = NULL;
#line 316 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (uslookup);
#line 316 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 1891 "gitg-credentials-manager.c"
}

static void
gitg_value_credentials_manager_init (GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	value->data[0].v_pointer = NULL;
#line 1899 "gitg-credentials-manager.c"
}

static void
gitg_value_credentials_manager_free_value (GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (value->data[0].v_pointer);
#line 1909 "gitg-credentials-manager.c"
	}
}

static void
gitg_value_credentials_manager_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		dest_value->data[0].v_pointer = gitg_credentials_manager_ref (src_value->data[0].v_pointer);
#line 1921 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1925 "gitg-credentials-manager.c"
	}
}

static gpointer
gitg_value_credentials_manager_peek_pointer (const GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return value->data[0].v_pointer;
#line 1934 "gitg-credentials-manager.c"
}

static gchar*
gitg_value_credentials_manager_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (collect_values[0].v_pointer) {
#line 1945 "gitg-credentials-manager.c"
		GitgCredentialsManager * object;
		object = collect_values[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1952 "gitg-credentials-manager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1956 "gitg-credentials-manager.c"
		}
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = gitg_credentials_manager_ref (object);
#line 1960 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 1964 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return NULL;
#line 1968 "gitg-credentials-manager.c"
}

static gchar*
gitg_value_credentials_manager_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	GitgCredentialsManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (!object_p) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1983 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (!value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = NULL;
#line 1989 "gitg-credentials-manager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = value->data[0].v_pointer;
#line 1993 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = gitg_credentials_manager_ref (value->data[0].v_pointer);
#line 1997 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return NULL;
#line 2001 "gitg-credentials-manager.c"
}

GParamSpec*
gitg_param_spec_credentials_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	GitgParamSpecCredentialsManager* spec;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return G_PARAM_SPEC (spec);
#line 2020 "gitg-credentials-manager.c"
}

gpointer
gitg_value_get_credentials_manager (const GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return value->data[0].v_pointer;
#line 2030 "gitg-credentials-manager.c"
}

void
gitg_value_set_credentials_manager (GValue* value,
                                    gpointer v_object)
{
	GitgCredentialsManager * old;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
	old = value->data[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (v_object) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = v_object;
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_ref (value->data[0].v_pointer);
#line 2052 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 2056 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (old) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (old);
#line 2062 "gitg-credentials-manager.c"
	}
}

void
gitg_value_take_credentials_manager (GValue* value,
                                     gpointer v_object)
{
	GitgCredentialsManager * old;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
	old = value->data[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (v_object) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = v_object;
#line 2083 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 2087 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (old) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (old);
#line 2093 "gitg-credentials-manager.c"
	}
}

static void
gitg_credentials_manager_class_init (GitgCredentialsManagerClass * klass,
                                     gpointer klass_data)
{
	SecretSchema* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_parent_class = g_type_class_peek_parent (klass);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	((GitgCredentialsManagerClass *) klass)->finalize = gitg_credentials_manager_finalize;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_type_class_adjust_private_offset (klass, &GitgCredentialsManager_private_offset);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = secret_schema_new (APPLICATION_ID ".Credentials", SECRET_SCHEMA_NONE, "scheme", SECRET_SCHEMA_ATTRIBUTE_STRING, "host", SECRET_SCHEMA_ATTRIBUTE_STRING, "user", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	_secret_schema_unref0 (gitg_credentials_manager_s_secret_schema);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_s_secret_schema = _tmp0_;
#line 2115 "gitg-credentials-manager.c"
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = g_regex_new ("^(?:[^: /@]+)@(?P<host>[^:]+)", 0, 0, &_inner_error0_);
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = _tmp2_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2126 "gitg-credentials-manager.c"
			goto __catch33_g_error;
		}
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp3_ = _tmp1_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = NULL;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_g_regex_unref0 (gitg_credentials_manager_s_ssh_short_form);
#line 50 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_s_ssh_short_form = _tmp3_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_g_regex_unref0 (_tmp1_);
#line 2139 "gitg-credentials-manager.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp4_ = stderr;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp5_ = e;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp6_ = _tmp5_->message;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp4_, "regex err: %s\n", _tmp6_);
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 2162 "gitg-credentials-manager.c"
	}
	__finally33:
#line 48 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 2171 "gitg-credentials-manager.c"
	}
}

static void
gitg_credentials_manager_instance_init (GitgCredentialsManager * self,
                                        gpointer klass)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self->priv = gitg_credentials_manager_get_instance_private (self);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self->ref_count = 1;
#line 2183 "gitg-credentials-manager.c"
}

static void
gitg_credentials_manager_finalize (GitgCredentialsManager * obj)
{
	GitgCredentialsManager * self;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManager);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_signal_handlers_destroy (self);
#line 30 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_config);
#line 31 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_window);
#line 32 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_usermap);
#line 34 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (self->priv->d_last_user);
#line 35 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_auth_tried);
#line 2204 "gitg-credentials-manager.c"
}

GType
gitg_credentials_manager_get_type (void)
{
	static volatile gsize gitg_credentials_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_credentials_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gitg_value_credentials_manager_init, gitg_value_credentials_manager_free_value, gitg_value_credentials_manager_copy_value, gitg_value_credentials_manager_peek_pointer, "p", gitg_value_credentials_manager_collect_value, "p", gitg_value_credentials_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GitgCredentialsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_credentials_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgCredentialsManager), 0, (GInstanceInitFunc) gitg_credentials_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gitg_credentials_manager_type_id;
		gitg_credentials_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgCredentialsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GitgCredentialsManager_private_offset = g_type_add_instance_private (gitg_credentials_manager_type_id, sizeof (GitgCredentialsManagerPrivate));
		g_once_init_leave (&gitg_credentials_manager_type_id__volatile, gitg_credentials_manager_type_id);
	}
	return gitg_credentials_manager_type_id__volatile;
}

gpointer
gitg_credentials_manager_ref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return instance;
#line 2232 "gitg-credentials-manager.c"
}

void
gitg_credentials_manager_unref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		GITG_CREDENTIALS_MANAGER_GET_CLASS (self)->finalize (self);
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2246 "gitg-credentials-manager.c"
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

